# VHBoomMenuButton
[![Developer](https://img.shields.io/badge/Developer-Nightonke-red.svg)](https://github.com/Nightonke)
[![Cocoapods](https://img.shields.io/badge/Cocoapods-2.0.0-blue.svg)](https://github.com/Nightonke/VHBoomMenuButton)
[![Lisense](https://img.shields.io/badge/License-MIT-lightgrey.svg)](https://github.com/Nightonke/VHBoomMenuButton/blob/master/LICENSE)

## 2.0.0 Comes Finally
After the version 2.0.0 has been published on [Android platform](https://github.com/Nightonke/BoomMenu), I started developing the new version for BMB on iOS platform. To be honest, it's not easy for me as a newbie in iOS-developing. I learned the Swift language to provide a [Swift version of BMB](https://github.com/Nightonke/VHBoomMenuButton/tree/master/VHBoomMenuButtonSwift) and added some new features which can be found in [Wiki](https://github.com/Nightonke/VHBoomMenuButton/wiki).

And now, just enjoy BMB.  
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/TextInsideCircleButton.gif" width="400"/>
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/SquareAndPieceCornerRadius.gif" width="400"/>
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/BlurBackgroundAndTip.gif" width="400"/>
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/NavigationBar.gif" width="400"/>
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/TableView.gif" width="400"/>
<img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/Share.gif" width="400"/>

## Pods
#### Swift
```
target 'Your Target Name' do
  pod "VHBoomMenuButton/Swift"
  use_frameworks!
end
```
#### Objective C
```
target 'Your Target Name' do
  pod "VHBoomMenuButton/ObjC"
  use_frameworks!
end
```

## Wiki
Check the [wiki](https://github.com/Nightonke/VHBoomMenuButton/wiki) to use BMB.

### Documentation Chapters
1. **Basic Usage** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Basic-Usage-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Basic-Usage-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    How to use BMB in just several lines of code? 
1. **Simple Circle Button** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Simple-Circle-Button-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Simple-Circle-Button-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Add simple circle buttons with just an image for each to BMB.
1. **Text Inside Circle Button** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Text-Inside-Circle-Button-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Text-Inside-Circle-Button-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Add text inside circle buttons with a text and image inside for each to BMB.
1. **Text Outside Circle Button** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Text-Outside-Circle-Button-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Text-Outside-Circle-Button-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Add text outside circle buttons with a text outside and an image inside for each to BMB.
1. **Ham Button** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Ham-Button-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Ham-Button-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Add ham buttons with with a text, sub-text and image inside for each to BMB.
1. **Share Style** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Share-Style-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Share-Style-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Make a share-style BMB.
1. **Custom Position** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Custom-Position-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Custom-Position-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Customize the number and positions of pieces and boom-buttons.
1. **Button Place Alignments** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Button-Place-Alignments-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Button-Place-Alignments-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Place all the buttons to anywhere on screen.
1. **Different Ways to Boom** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Different-Ways-to-Boom-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Different-Ways-to-Boom-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Different animations when the buttons boom or re-boom.
1. **Ease Animations for Buttons** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Ease-Animations-for-Buttons-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Ease-Animations-for-Buttons-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Use different and cute ease-animations for buttons.
1. **Different Order for Buttons** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Different-Order-for-Buttons-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Different-Order-for-Buttons-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Different order enum for boom-buttons.
1. **Other Animations Attributes for Buttons** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Other-Animations-Attributes-for-Buttons-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Other-Animations-Attributes-for-Buttons-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Delay, duration, rotate-degrees, frames...
1. **Click Event and Listener** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Click-Event-and-Listener-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Click-Event-and-Listener-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Listener for clicking each button or animation-states. 
1. **Control BMB** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Control-BMB-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Control-BMB-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Boom or re-boom BMB programmatically.
1. **Use BMB in Navigation Bar** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Use-BMB-in-Navigation-Bar-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Use-BMB-in-Navigation-Bar-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    How to put BMB in navigation bar?
1. **Use BMB in Table View** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Use-BMB-in-Table-View-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Use-BMB-in-Table-View-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Attentions when you need a BMB in table-view.
1. **Attributes for BMB or Pieces on BMB** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Attributes-for-BMB-or-Pieces-on-BMB-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Attributes-for-BMB-or-Pieces-on-BMB-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    How to change the size or margins of dots on BMB?
1. **Cache Optimization & Boom Area** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Cache-Optimization-&-Boom-Area-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Cache-Optimization-&-Boom-Area-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    What if I want BMB to boom in just its parent-view?
1. **Change Boom Buttons Dynamically** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Change-Boom-Buttons-Dynamically-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Change-Boom-Buttons-Dynamically-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Change boom-buttons dynamically.
1. **Blur Background & Tip** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Blur-Background-&-Tip-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Blur-Background-&-Tip-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Blur background when booming.
1. **Fade Views** <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Fade-Views-(Swift)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/swift.png" width="15"></a> <a href="https://github.com/Nightonke/VHBoomMenuButton/wiki/Fade-Views-(Objective-C)"><img src="https://github.com/Nightonke/BoomMenuButton-Images/blob/master/iOS/objective-c.png" width="15"></a>  
    Add faded views on BMB.
1. [**Structure of BMB**](https://github.com/Nightonke/VHBoomMenuButton/wiki/Structure-of-BMB)
1. [**Version History**](https://github.com/Nightonke/VHBoomMenuButton/wiki/Version-History)

### Issues & Feedbacks
Try to tell me the bugs or enhancements about BMB, or contact me with Nightonke@outlook.com / 2584541288@qq.com. Before doing that, having a careful read on readme, wiki and issues is really helpful. 

## [What I'm Doing](http://huangweiping.me/)
